// Code generated by thor;
// thor

package groupstore

import (
	"context"
	"errors"
	"time"

	groupstatus "demo/internal/constant/group-status"
	"demo/internal/model/entity"

	"github.com/jinzhu/gorm"
)

var (
	ErrMissingID     = errors.New("missing id")
	ErrNotFoundGroup = errors.New("not found group")
)

// GetActiveByID ...
func (o *groupRepoImpl) getActiveByID(ctx context.Context, id string) (*entity.Group, error) {
	var object = &entity.Group{}
	err := o.Model(entity.Group{}).Where("id = ? AND status = ?", id, groupstatus.Active).First(object).Error
	if err == gorm.ErrRecordNotFound {
		return nil, ErrNotFoundGroup
	}
	return object, err
}

// ListActive ...
func (o *groupRepoImpl) listActive(ctx context.Context, limit int64, offset int64) ([]*entity.Group, error) {
	objs := make([]*entity.Group, 0)
	err := o.Limit(limit).Offset(offset).Where("status = ?", groupstatus.Active).
		Limit(limit).Offset(offset).
		Order("id desc").Find(&objs).Error
	if err != nil && err == gorm.ErrRecordNotFound {
		err = nil
	}
	return objs, err
}

// Remove ...
func (o *groupRepoImpl) remove(ctx context.Context, id string) error {
	if len(id) == 0 {
		return ErrMissingID
	}
	return o.Model(entity.Group{}).Where("id = ?", id).
		Updates(map[string]interface{}{"status": groupstatus.Deleted, "deleted_at": time.Now().Unix()}).Error
}

// Save ...
func (o *groupRepoImpl) save(ctx context.Context, obj *entity.Group) error {
	obj.BeforeCreate()
	return o.Create(obj).Scan(obj).Error
}

// Save ...
func (o *groupRepoImpl) setDefault(ctx context.Context, id string, isDefault bool) (*entity.Group, error) {
	if len(id) == 0 {
		return nil, ErrMissingID
	}
	currObj, err := o.getActiveByID(ctx, id)
	if err != nil {
		return nil, err
	}
	return currObj, o.Model(currObj).Omit("id").
		Updates(map[string]interface{}{"is_default": isDefault}).Scan(currObj).Error
}

// UpdateMap ...
func (o *groupRepoImpl) updateMap(ctx context.Context, id string, obj map[string]interface{}) (*entity.Group, error) {
	if len(id) == 0 {
		return nil, ErrMissingID
	}
	currObj, err := o.getActiveByID(ctx, id)
	if err != nil {
		return nil, err
	}
	return currObj, o.Model(currObj).Omit("id").Updates(obj).Scan(currObj).Error
}
